You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 

166 lines
4.5 KiB

  1. #! /bin/sh
  2. ### BEGIN INIT INFO
  3. # Provides: skeleton
  4. # Required-Start: $remote_fs $syslog
  5. # Required-Stop: $remote_fs $syslog
  6. # Default-Start: 2 3 4 5
  7. # Default-Stop: 0 1 6
  8. # Short-Description: Example initscript
  9. # Description: This file should be used to construct scripts to be
  10. # placed in /etc/init.d.
  11. ### END INIT INFO
  12. # Author: Foo Bar <foobar@baz.org>
  13. #
  14. # Please remove the "Author" lines above and replace them
  15. # with your own name if you copy and modify this script.
  16. # Do NOT "set -e"
  17. # PATH should only include /usr/* if it runs after the mountnfs.sh script
  18. PATH=/sbin:/usr/sbin:/bin:/usr/bin:/usr/local/go/bin
  19. DESC="Transfersh Web server"
  20. NAME=transfersh
  21. DAEMON="/opt/transfer.sh/main"
  22. DAEMON_ARGS="--port 80 --temp /tmp/"
  23. PIDFILE=/var/run/$NAME.pid
  24. SCRIPTNAME=/etc/init.d/$NAME
  25. export BUCKET={bucket}
  26. export AWS_ACCESS_KEY={aws_access_key}
  27. export AWS_SECRET_KEY={aws_secret_key}
  28. export VIRUSTOTAL_KEY={virustotal_key}
  29. export GOPATH=/opt/go/
  30. # Exit if the package is not installed
  31. [ -x "$DAEMON" ] || exit 0
  32. # Read configuration variable file if it is present
  33. [ -r /etc/default/$NAME ] && . /etc/default/$NAME
  34. # Load the VERBOSE setting and other rcS variables
  35. . /lib/init/vars.sh
  36. # Define LSB log_* functions.
  37. # Depend on lsb-base (>= 3.2-14) to ensure that this file is present
  38. # and status_of_proc is working.
  39. . /lib/lsb/init-functions
  40. #
  41. # Function that starts the daemon/service
  42. #
  43. do_start()
  44. {
  45. # Return
  46. # 0 if daemon has been started
  47. # 1 if daemon was already running
  48. # 2 if daemon could not be started
  49. start-stop-daemon --background --start --chdir /opt/transfer.sh --quiet --pidfile $PIDFILE --make-pidfile --exec $DAEMON --test > /dev/null \
  50. || return 1
  51. start-stop-daemon --background --start --chdir /opt/transfer.sh --quiet --pidfile $PIDFILE --make-pidfile --exec $DAEMON -- \
  52. $DAEMON_ARGS \
  53. || return 2
  54. # Add code here, if necessary, that waits for the process to be ready
  55. # to handle requests from services started subsequently which depend
  56. # on this one. As a last resort, sleep for some time.
  57. }
  58. #
  59. # Function that stops the daemon/service
  60. #
  61. do_stop()
  62. {
  63. # Return
  64. # 0 if daemon has been stopped
  65. # 1 if daemon was already stopped
  66. # 2 if daemon could not be stopped
  67. # other if a failure occurred
  68. start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
  69. RETVAL="$?"
  70. [ "$RETVAL" = 2 ] && return 2
  71. # Wait for children to finish too if this is a daemon that forks
  72. # and if the daemon is only ever run from this initscript.
  73. # If the above conditions are not satisfied then add some other code
  74. # that waits for the process to drop all resources that could be
  75. # needed by services started subsequently. A last resort is to
  76. # sleep for some time.
  77. start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
  78. [ "$?" = 2 ] && return 2
  79. # Many daemons don't delete their pidfiles when they exit.
  80. rm -f $PIDFILE
  81. return "$RETVAL"
  82. }
  83. #
  84. # Function that sends a SIGHUP to the daemon/service
  85. #
  86. do_reload() {
  87. #
  88. # If the daemon can reload its configuration without
  89. # restarting (for example, when it is sent a SIGHUP),
  90. # then implement that here.
  91. #
  92. start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
  93. return 0
  94. }
  95. case "$1" in
  96. start)
  97. [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
  98. do_start
  99. case "$?" in
  100. 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
  101. 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
  102. esac
  103. ;;
  104. stop)
  105. [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
  106. do_stop
  107. case "$?" in
  108. 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
  109. 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
  110. esac
  111. ;;
  112. status)
  113. status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
  114. ;;
  115. #reload|force-reload)
  116. #
  117. # If do_reload() is not implemented then leave this commented out
  118. # and leave 'force-reload' as an alias for 'restart'.
  119. #
  120. #log_daemon_msg "Reloading $DESC" "$NAME"
  121. #do_reload
  122. #log_end_msg $?
  123. #;;
  124. restart|force-reload)
  125. #
  126. # If the "reload" option is implemented then remove the
  127. # 'force-reload' alias
  128. #
  129. log_daemon_msg "Restarting $DESC" "$NAME"
  130. do_stop
  131. case "$?" in
  132. 0|1)
  133. do_start
  134. case "$?" in
  135. 0) log_end_msg 0 ;;
  136. 1) log_end_msg 1 ;; # Old process is still running
  137. *) log_end_msg 1 ;; # Failed to start
  138. esac
  139. ;;
  140. *)
  141. # Failed to stop
  142. log_end_msg 1
  143. ;;
  144. esac
  145. ;;
  146. *)
  147. #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
  148. echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
  149. exit 3
  150. ;;
  151. esac
  152. :